clear
// Fréquence du signal 312Hz
f0=312;
// Numérisation de 1024 valeurs
N=1024;
// Variation de la fréquence d'échantillonnage entre 750 et 500Hz par pas de 50Hz
for Fe=750:-50:500 
    // Instants de mesure
    te=(0:N-1)/Fe;
    // Signal temporel
    x=sin(2*%pi*f0*te);
    // Calcul de a fft du signal
    X=fft(x);
    [mx,p]=max(abs(X(1:N/2)));
    // Tracé du spectre entre -Fe/2 et Fe/2 sur la figure 0
    f=(-fix(N/2):N-fix(N/2)-1)/N*Fe;
    figure(0)
    // Désactivation des commandes graphiques sur l'écran
    drawlater
    clf();
    title(['Spectre d''une sinusoïde de fréquence '+string(f0)+'Hz numérisée à '+string(Fe)+'Hz '],'fontsize',4);
    // Modification de la taille des caractères de la dernière commande graphique (title)
    h=gce(); 
    h.font_size=4;
    plot(f,abs(fftshift(X)))
    xstring(f(1),mx/2,['Fréquence mesurée :  '+string(fix(f(p+N/2)*10)/10)+'±'+string(fix(100*Fe/N)/100)+'Hz']);
    // Modification de la taille des caractères de la dernière commande graphique (xstring)
    h=gce() 
    h.font_size=4;
    // Si le maximum du spectre n'est pas à la fréquence f0 on écrit en rouge sinon en vert
    if abs(f(p+N/2)-f0)<Fe/N then
        h.font_foreground=3
    else
        h.font_foreground=5;
    end
    xgrid();
    // Réactivation des commandes graphiques sur l'écran
    drawnow
    // Pause de 2 secondes
    xpause(2000000)
end

