clear;
stacksize('max')

// ***************************************************************
// Constantes du programme
// ***************************************************************
demiton=2^(1/12);            // Rapport fréquentiel entre 2 demi-tons consécutifs
laref=27.5;                  // Fréquence en Hz du la-1
Fe=22050;                    // Fréquence de restitution du son
freqNote=[0 2 3 5 7 8 10 ];  // Nombre de demi-tons entre les notes de la gamme en partant du la


// ***************************************************************
//  Définition des fonctions
// ***************************************************************
function n=Amortissement(t)
    n=exp(-t);
endfunction
// ****************************************************************
function n=Synthese(note,dureeNote,amplitudeHarmo,fct)
    t=0:1/Fe:dureeNote;
    n=zeros(1,size(t,2));
    f0=laref
    noteRef=note;
    for i=1:length(amplitudeHarmo)
        nu0=i*noteRef;
        n=n+amplitudeHarmo(i)*eval(fct);
    end
endfunction


// ***************************************************************
//  Synthèse de la mélodie
// ***************************************************************
canald=[];   // Valeur du signal stéréophonique pour le canal droit
canalg=[];   // Valeur du signal stéréophonique pour le canal gauche
tempo=120;  // 120 noires par minute
// Partition à jouer
melodie=['A2dA#2nB2nC2nC#2nD2nD#2nE2nF2nF#2nG2nG#2n']

instrument='sin(2*%pi*nu0*t).*Amortissement(-t)';
harmonique=[0.13 0.1 0.07 0.2 0.18 0.04 0.01 0.04 0.04 0.06 0.03 0. 0. 0.02 0.02 0.02];
i=1;
// Parcours de la partition
while (i<length(melodie))
// Extraction de la note suivante de la partition
  fNote=freqNote(ascii(part(melodie,i))-64);
  i=i+1;
// La note est-elle altérée?
  if (part(melodie,i)=='#')
      fNote=fNote+1;
      i=i+1;
  end
// Modification de la fréquence par rapport à l'octave 
  fNote=fNote+(ascii(part(melodie,i))-48)*12;
  i=i+1;
// Extraction de la durée de la note
  select (part(melodie,i))
  case 'r' then duree=4;
  case 'b' then duree=2;
  case 'n' then duree=1;
  case 'c' then duree=0.5;
  case 'd' then duree=0.25;
  end         
// Synthèse de l'aspect temporel de la note
  noted=Synthese(2^(fNote/12)*laref,duree/tempo*60,harmonique,instrument);
  noteg=Synthese(2^(fNote/12)*laref,duree/tempo*60,harmonique,instrument);
// Ajout des notes sur les voix droite et gauche
  canald=[canal noted];
  canalg=[canalg noteg];
  i=i+1;
end
// Ecoute de la mélodie
playsnd([canald;canalg],Fe)
