clear;
// *****************************************************************************
function y=Porte(t)
    ind=find(t<-1/2 | t>1/2);
    y=ones(size(t,1),size(t,2));
    if length(ind)>0
        y(ind)=0;
    end
endfunction


// Fréquence d'échantillonnage
Fe=22050;
// Fréquence du signal en Hz
nu=880;
// Durée du signal enregistré
t=(0:1/Fe:1);
// Durée de la trame
D=0.15;
// valeur de retard de l'écho
vRetard=0.5;
// Trame émise
saRef=sin(2.*%pi.*nu.*t).*Porte((t-D/2)/D);		
// Amplitude du bruit gaussien
Ab=0.05;  
// valeur du bruit         
saEcho=Ab.*rand(saRef,'normal');
// Construction de l'écho
indNonNul=find(abs(saRef)>0);
// Recherche dans le vecteur t de la valeur la plus proche de vRetard
[v indRetard]=min(abs(vRetard-t));
// Insertion de la trame décalée amortie
saEcho(indNonNul+indRetard)=saEcho(indNonNul+indRetard)+1/4*saRef(indNonNul);
// Calcul de l'intercorrélation entre l'écho et la trame
[c tau]=xcorr(saEcho,saRef);
// Recherche du maximum de l'intercorrélation
[mC eRetard]=max(c);
figure(1);
clf();
// Graphique du haut
subplot(2,1,1)
// Tracé du signal de référence en rouge et en bleu de l'écho 
plot(t,saRef,'r',t,saEcho,'b')
// Graphique du bas
xgrid();
subplot(2,1,2)
// tracé du résultat de l'intercorrélation
plot(tau/Fe,c)
a=gca();
xtitle('temps','decalage temporel','fonction de intercorrelation')
xlabel('Time(s)')
ylabel('Cxy');
// Affichage sur le graphique du retard fixé
xstring(-1,mC/2,['Retard fixé ='+string(vRetard)])
// Affichage sur le graphique du retard estimé par intercorrélation
xstring(-1,0,['Retard estimé ='+string(t(max(1,eRetard-length(t))))])
xgrid();
sound(saEcho/max(abs(saEcho)),Fe)

