clear;
// Choix par l'utilisateur du fichier wav
nomFichier=uigetfile(["*.wav"])
// Lecture du fichier
[vp Fe]=wavread(nomFichier);
// Nombre d'échantillons dans le vecteur vp
N=size(vp,2);
// Variable temps en seconde
t=(0:N-1)/Fe;
// Spectre des signaux modulés
X=fft(vp);
// Tracé du spectre pour déterminer le nombre de porteuses
figure(1);
clf();
f=(-N/2:N/2-1)/N*Fe;
plot(f,fftshift(log(abs(X))))
xgrid;
xlabel('Frequence (Hz)');
ylabel('|X| (dB)')
// Demande à l'utilisateur du nombre de porteuses visibles
[ok nbFrequence]=getvalue("Porteuse",'Nombre de porteuses',list('row',1),"3");
// Largeur du filtre passe-bas (unité fréquence normalisée)
larFiltre=0.05;
// Fréquence des ondes porteuses
f0=(1:nbFrequence)*1.5*larFiltre*Fe;
// Fonction transfert du filtre passe-bas
hzPB=iir(8,'lp','ellip',[larFiltre 0],[.05 0.001]); 
// Variable contenant les signaux modulants
sdm=[];
for i=1:nbFrequence
    // Construction de la i ème porteuse
    p=cos(2*%pi*f0(i)*t);
    // produit de vp par l'onde porteuse
    m=vp.*p(1:length(vp));
    // filtrage passe-bas du produit pour extraire le signal modulant
    sdm=[sdm ;filter(hzPB.num,hzPB.den,m)];
    // Écoute du signal extrait
    playsnd(sdm(i,:)/max(sdm(i,:)),Fe);
    xpause(length(t)/Fe*1000000);
end
