// Nombre d'échantillons du signal
N=2^17;
// Fréquence d'échantillonnage
Fe=44100;
// Variable temps en seconde
t=(0:N-1)/Fe;
// Signal modulé
vp=zeros(1,N);
// Nom des fichiers wav modulants
nomFichier=list('s4.wav','s2.wav','s1.wav');
// Largeur en fréquence normalisée du filtre passe bas
larFiltre=2200/Fe;
// Vecteur des fréquences des ondes porteuses
f=(1:size(nomFichier))*1.5*larFiltre*Fe;
// Facteur de modulation
m=1;
// Nombre d'éléments du filtre à réponse impulsionnelle finie
nbEltFiltre=256;
// Construction du filtre passe bas à appliquer aux signaux modulants
hn=eqfir(nbEltFiltre,[0 larFiltre;larFiltre*1.1 .5],[1 0],[1 1]);
for i=1:size(nomFichier)
    // Lecture du son dans le fichier wav
    [xSon Fes]=wavread(nomFichier(i));
    // Filtrage passe bas du son
    xSon=conv(xSon(1,:),hn);
    [nblx nbcx]=size(xSon);
    // Les sons ne comportent pas le même nombre d'échantillons, il faut ajuster la taille
    s(i,:)=[xSon(1,1:min(N-nbEltFiltre+1,nbcx-nbEltFiltre+1)) zeros(1,max(N-nbcx,0))]; 
    // Construction de l'onde porteuse
    p=cos(2*%pi*f(i)*t(1:N-nbEltFiltre+1));
    // Produit du signal filtré par l'onde porteuse
    vpi=(1+m*s(i,:)).*p;
    // Construction du filtre passe-bande pour supprimer une bande latérale
    hni=eqfir(nbEltFiltre,[0 f(i)/Fe;(f(i)+20)/Fe  f0(i)/Fe+larFiltre; f0(i)/Fe+larFiltre*1.01 0.5],[0 1 0],[1 1 1]);
    // Suppression de la bande latérale
    vpi=conv(vpi,hni);
    // Ajout du signal modulé aux supports
    vp=vp + vpi;
end
// Le signal son contient les sons modulés
wavwrite(vp/max(abs(vp)),Fe,'modulFiltreRIF.wav')
