clear;
// Nombre d'échantillons du signal
N=2^17;
// Fréquence d'échantillonnage
Fe =22050;
// Variable temps en seconde
t=(0:N-1)/Fe;
// Signal modulé
vp=zeros(1,N);
// Demande des fichiers à moduler à l'utilisateur
nomFichier=uigetfile(['*.wav'],'./','Fichiers à moduler',%t);
// Largeur en fréquence normalisé du filtre passe-bas
larFiltre=0.05;
// Vecteur des fréquences des ondes porteuses
f=(1:size(nomFichier,2))*1.5*larFiltre;
// Facteur de modulation
m=1;
// Ordre du filtre
nbEltFiltre=8;
hzPB=iir(nbEltFiltre,'lp','ellip',[larFiltre 0],[.05 0.001]);

hzBLS= zeros(size(nomFichier,2),1)
for i=1:size(nomFichier,2)
    // Lecture du fichier wav
    [xSon Fes]=wavread(nomFichier(i));
    // si les fréquences ne sont pas identiques on ré-echantillonne le signal
    if Fe<>Fes then
       xSon=intdec(xSon,Fe/Fes); 
    end
    // Filtrage passe-bas du signal
    xSon=filter(hzPB.num,hzPB.den,xSon(1,:));
    // Les sons ne comportent pas le même nombre d'échantillons, il faut ajuster la taille
    [nblx nbcx]=size(xSon);
    s=[xSon(1,1:min(N-nbEltFiltre+1,nbcx-nbEltFiltre+1)) zeros(1,max(N-nbcx,0))]; 
    // Construction de l'onde porteuse
    p=cos(2*%pi*f(i)*t(1:N-nbEltFiltre+1));
    vpi=(0.01+m*s).*p;
    // Construction du filtre passe-bande pour supprimer une bande latérale
    hzBLS(i,:)=iir(nbEltFiltre,'bp','ellip',[   f(i)/Fe f(i)/Fe+larFiltre],[.08 0.001]);
    // Suppression de la bande latérale
    vpii=filter(hzBLS(i,:).num,hzBLS(i,:).den,vpi);
    // Ajout du signal modulé aux supports
    vp=vp(1:length(vpii)) + vpii;
end
wavwrite(vp/max(abs(vp)),Fe,'modulFiltreRII.wav')
