clear;
// ***************************************************************
//  Définition des fonctions
// ***************************************************************
function y=Porte(x)
    y=zeros(size(t,1),size(t,2));
    ind=find(x>-0.5 & x<0.50);
    if length(ind)>0
        y(ind)=1;
    end
endfunction
// ***************************************************************
function y=Triangle(t)
    y=zeros(size(t,1),size(t,2));
    ind=find(t>-1/2 & t<=0);
    y(ind)=1+2*t(ind);
    ind=find(t>0 & t<=1/2);
    y(ind)=1-2*t(ind);
endfunction
// ***************************************************************

// Échelle du signal
p=6
// Nombre d'échantillon
N=2^p;
// Durée du signal
D=1;
// Expression littérale de la fonction
fct='Porte((t-D/10)/(D/10))+Triangle((t-D/3)/(D/3))+Porte((t-3*D/4)/(D/2)).*sin(2*%pi/(D/4)*t)+0.2*Porte((t-7*D/8)/(D/4)).*sin(2*%pi/(D/11.14)*t)';
// Période d'échantillonnage
Te=1/N;
// Temps échantillonné
te=(0:N-1)*Te;
// Évaluation de la fonction au point t
t=te;
y=eval(fct);
// Ondelette de Daubechie avec 4 moments nuls
wavatome='db4';
// Valeurs de l'ondelette psi et de la fonction d'échelle phi au point xval
[phidb,psidb,xval]=wavefun(wavatome,1);
// Position des valeurs non nulles de psi 
ind=find(abs(psidb)>0);
// Suppression des valeurs nulles aux extrémités 
psidb=psidb(min(ind):max(ind));
nbPsi=size(psidb,2);
// Position des valeurs non nulles de phi 
ind=find(abs(phidb)>0);
// Suppression des valeurs nulles aux extrémités 
phidb=phidb(min(ind):max(ind));
// calcul des coefficients d'ondelette discret
[clow chigh]=dwt(y,wavatome,'mode','zpd');
// Comparaison avec la convolution
wh=conv([y],psidb($:-1:1));
wl=conv([y],phidb($:-1:1));
// Calcul de l'ondelette continue
wcwt=cwt([y zeros(1,length(phidb))],2,wavatome);
figure(1);clf();
plot(wh(2:$)/sqrt(2),'r-+')
plot(2*(1:length(chigh))-1,chigh,'bo')
plot([wcwt],'g');
legend('conv','dwt','cwt')
title('Coefficients de détails');
xgrid();
figure(2);clf();
plot(2*(1:length(clow))-1,clow,'bo')
plot(wl(2:$)/sqrt(2),'r-+','thickness',1)
legend('conv','dwt')
xlabel('temps')
title('Coefficients d''approximation');
xgrid();


