 clear;
// ***************************************************************
//  Définition des fonctions
// ***************************************************************
function TypeOndelette(indNom)
// Fonction appelée lors du clic sur des boutons des ondelettes
    ondPossible=grep(nomWv,typeWv(indNom,2));
// Mise en place du menu associé lors du clic bouton
    hMenu = uicontextmenu();
// Mise en place des articles du menu 
    for i=1:length(ondPossible)
// Fonction appelée lors de la sélection de l'article
        fct="TraceOndelette("""+nomWv(ondPossible(i))+""","+string(indNom)+")";
        disp(fct)
// Ajout de l'article au menu
        hItem1 = uimenu("Label", nomWv(ondPossible(i)), "Parent", hMenu, "Callback", fct,"Callback_Type",2);
    end
endfunction
// ***************************************************************
function TraceOndelette(nom,indNom)
// Fonction appelée lors du clic sur l'un des articles des menus des boutons des ondelettes
// On a besoin de modifier la variable globale wname
    global wname
// Nom de l'ondelette choisie par l'utilsateur
    wname=nom;
    figure(0);
    clf()
    if grep(wname,'bior')==1 then
        [phi,psi,phi2,psi2,x]=wavefun(wname,10);
        subplot(211)
        title('Fonction d''échelle');
        plot(x,phi2,'b')
        subplot(212)
        title('Ondelette ');
        plot(x,psi2,'b')
    else
        [phi,psi,x]=wavefun(wname,10);
    end
    subplot(211)
    title(['Fonction d''échelle '+typeWv(indNom,1)+' : '+wname]);
    plot(x,phi,'r')
    xgrid;
    legend('Fonction d''échelle','Fonction d''échelle ~')
    subplot(212)
    title(['Ondelette'+typeWv(indNom,1)+' : '+wname]);
    plot(x,psi,'r')
    xgrid
    legend('Ondelette','ondelette ~')
endfunction
// ***************************************************************
function ParamFiltrage()
// Fonction appelée lors du clic sur le bouton FILTRER
// On a besoin de modifier la variable globale rep
    global rep
// Recherche de la boite nommé critere
    h=findobj("tag","critere");
// Valeur sélectionnée par l'utilisateur
    rep(1)=h.value;
// Recherche de la boite nommé type
    h=findobj("tag","type");
// Valeur sélectionnée par l'utilisateur
    rep(2)=h.value
// Recherche de la boite nommé ajustement
    h=findobj("tag","ajustement");
// Valeur sélectionnée par l'utilisateur
    rep(3)=h.value;
    Filtrer();
endfunction
// ***************************************************************
function Filtrer()
// Variables globales modifiées par la fonction
    global yFiltre filtrage 
// Paramètres de la fonction wden
    TPTR=list('TPTR',1,['rigrsure','heursure','sqtwolog','minimaxi'])
    SCAL=list('SCAL',1,['one','sln','mln'])
    SORH=list('SORH',1,['h','s'])
// Niveau maximum de décomposotiion possible avec le signal y et l'ondelette wname
    nivMax=wmaxlev(length(y),wname);
    figure(1);
    clf();
// Tracé de la décompostion en ondelette du signal original
    dwtplot(yOrig,wname,'dec',nivMax,nivMax,0);
    title('signal original non bruité')
// A chaque niveau le résultat du filtrage est rangé dans yFiltre
    yFiltre=zeros(nivMax,N);
// tableau de chaînes de caractères pour le menu  du bouton ECOUTER
    filtrage=[];
// Boucle de filtrage
    for niveau=1:nivMax
// filtrage 
        [yden,cxd,lxd] = wden(y,TPTR(3)(rep(1)),SORH(3)(rep(2)),SCAL(3)(rep(3)),niveau,wname);
// résultat du filtrage du signal normalisé en vue de l'écoute
        yFiltre(niveau,:)=yden/max(abs(yden));
        figure(2);
        drawlater;
        clf();
        dwtplot(yden,wname,'dec',niveau,0,0);
        title('signal filtré')
        drawnow;
        filtrage(niveau)=['niveau '+string(niveau)];
    end
// Ajout de deux choix au menu  du bouton ECOUTER
    filtrage(nivMax+1)=['Original'];
    filtrage(nivMax+2)=['Original+bruit'];
endfunction
// ***************************************************************
function MenuEcoute()
// Fonction appelée lors du clic sur le bouton ECOUTER
// Creation du menu associé lors du clic bouton
    hMenu = uicontextmenu();
// Mise en place des articles du menu 
    for i=1:size(filtrage,1)
// Fonction appelée lors de la sélection de l'article
        fct=["EcouteSignal("+string(i)+")"];
// Ajout de l'article au menu
        hItem = uimenu("Label", filtrage(i), "Parent", hMenu, "Callback", fct,"Callback_Type",2);
    end
endfunction
// ***************************************************************
function EcouteSignal(ecoute)
// Fonction appelée lors du clic sur l'un des articles du menu du bouton ECOUTER
    nivMax=wmaxlev(length(y),wname);
    if (ecoute>0 )
        if ecoute <=nivMax then
            playsnd(yFiltre(ecoute,:),Fe)
        else if  ecoute ==nivMax+1 then
                playsnd(yOrig,Fe)
            else
                playsnd(y,Fe)
            end
        end
    end
endfunction
// ***************************************************************
function y=Porte(t)
    ind=find(t<-1/2 | t>1/2);
    y=ones(size(t,1),size(t,2));
    if length(ind)>0
        y(ind)=0;
    end
endfunction
// ***************************************************************
// Variables globales modifiables par les fonctions
global y yOrig wname TPR SORH SCAL filtrage rep yFiltre
wname='haar';
// Lecture de la source du signal
sourceSignal=list('Source :',3,['fichier wav','Microphone via portaudio','simulation']);
chxSource=x_choices('Origne du signal',list(sourceSignal));
select chxSource
    case 1 then
// Demande du chemin et nom du fichier de données
        PathFileName=uigetfile('*.wav');
// Lecture des données
        [y Fe]=wavread(PathFileName);
// Si le son est sur deux voix on le transforme en une
        if  size(y,1)==2 then
            y =mean(y,'r');
        end
        N=length(y);
// Variable temps en seconde
        yOrig=y;
    case 2 then
// Saisie des paramètres de l'acquisition
        [ok,N,Fe]=getvalue("Paramètre de l''échantillonnage",["nombre d''échantillons";"Fe"],list("vec",1,"vec",1),["16384";"11025"]);
        t=(0:N-1)/Fe;
        y=pa_recordwav(N,Fe,1);
    case 3  then
// Saisie des paramètres Fe et N (durée de l'échantillonnage)
        [ok,N,Fe]=getvalue("Paramètre de l''échantillonnage",["nombre d''échantillons";"Fe"],list("vec",1,"vec",1),["4096";"11025"]);
// Compostion d'un accord majeur
        majeur=[1 2^(4/12) 2^(7/12)];
// Compostion d'un accord mineur
        mineur=[1 2^(3/12) 2^(7/12)];
// Fréquences des notes de la gamme
        gamme=220*[1 2^(2/12) 2^(3/12) 2^(5/12) 2^(7/12) 2^(8/12) 2^(10/12)];
// Liste pour la fenêtre de dialogue
        noteM=list('Note majeure',1,['A','B','C','D','E','F','G']);
        notem=list('Note mineure',1,['A','B','C','D','E','F','G']);
        rep=x_choices('Première note',list(noteM,notem));
// Valeur de l'amplitude du bruit
        [ok v]=getvalue("Ajout de bruit gaussien",["Ecart type"],list("vec",1),["1"]);
        t=(0:N-1)/Fe;
        D=max(t);
        f=gamme(rep(1));
// Accord majeur choisi avec amortissement d'une durée D/2 à D/4
        yOrig=Porte((t-D/4)/(D/2)).*(sin(2*%pi*f*t)+0*sin(2*%pi*majeur(2)*f*t)+0*sin(2*%pi*majeur(3)*f*t)).*exp(-4*t);
        f=gamme(rep(2));
// Accord mineur choisi avec amortissement d'une durée D/2 à 3D/4
        yOrig=yOrig+Porte((t-3*D/4)/(D/2)).*(sin(2*%pi*f*(t-D/2))+0*sin(2*%pi*mineur(2)*f*(t-D/2))+0*sin(2*%pi*mineur(3)*f*(t-D/2))).*exp(-4*(t-D/2));
//  Ajout du bruit  
        y=yOrig+v*rand(yOrig,'n');;
    end

// Lecture des ondelettes disponibles
typeWv=csvRead('typeOndelette.txt','\t','.','string');
nomWv=csvRead('nomOndelette.txt','\n','.','string');

f=figure(5);
close(f);
f=figure(5);
// Mise en place des 11 boutons dans la figure 5 par une boucle
for indDWT=1:11
// Fonction appelée lors du clic sur le bouton avec en paramètre la valeur de l'indice de boucle
    fct="TypeOndelette("+string(indDWT)+")";
// Mise en place d'un article pushbutton avec un callback(fonction) associé à la fonction précédente avec le paramètre inclus. 
// La position dépend de l'indice de boucle
    h=uicontrol(f,"style","pushbutton","string",typeWv(indDWT,1),"callback",fct,"Callback_Type",2,"position",[10 100+(11-indDWT)*30 100 20]);
end

// Mise en place de trois listes.
rep=zeros(3,1);
// bouton pour l'ajustement du seuil par niveau
ajtSeuil=['aucun','Ajustement d''après niveau 1','ajustement dépendant du niveau'];
h=uicontrol(f,"style","listbox","string",ajtSeuil,"position",[120 280 250 100],"tag","ajustement","Relief","sunken");
// Article 1 de la liste sélectionné par défaut
h.value=1;
// bouton pour le type du seuil
tySeuil=['Dur','Doux'];
h=uicontrol(f,"style","listbox","string",tySeuil,"position",[120 200 250 60],"tag","type","Relief","sunken");
// Article 1 de la liste sélectionné par défaut
h.value=1;
// bouton pour les critères du seuil
chxSeuil=['Principe de Stein du risque sans biais','Variante heuristique du risque sans biais','Seuil universel','Seuil Minimax'];
h=uicontrol(f,"style","listbox","string",chxSeuil,"position",[120 100 250 80],"tag","critere","Relief","sunken");
// Article 1 de la liste sélectionné par défaut
h.value=1;
// Mise en place des boutons pour filtrer le signal et écouter les résultats
// bouton FILTRER avec callback ParamFiltrage
h=uicontrol(f,"style","pushbutton","string","FILTRER","position",[390 200 60 60],"Relief","sunken","callback","ParamFiltrage","Callback_Type",2);
// bouton FILTRER avec callback MenuEcoute
h=uicontrol(f,"style","pushbutton","string","ECOUTER","position",[470 200 60 60],"Relief","sunken","callback","MenuEcoute","Callback_Type",2);

    



