clear;
stacksize('max');

function X=TFCT(x,w,pas,signe)
    larFen=length(w);
    if signe==-1 then
        N=length(x);
        origFen=1:pas:N-1;
        X=zeros(larFen,length(origFen));
         for i=1:length(origFen)
            xf=[x(origFen(i):min(origFen(i)+larFen-1,N));zeros(larFen-(min(origFen(i)+larFen-1,N)-origFen(i)+1),1)];
            X(:,i)=fft(xf.*w);
        end
    else
        X=zeros(signe,1);
        sw2=zeros(signe,1);
        [nbFreq nbSpectre ]=size(x);
        for i=1:nbSpectre
            ind=(i-1)*pas+1:min((i-1)*pas+larFen,length(X));
            xx=ifft(x(:,i)).*w;
            X(ind)= X(ind)+xx(1:ind($)-ind(1)+1);
            sw2(ind)=sw2(ind)+w(1:ind($)-ind(1)+1).^2;
        end
        ind=find(sw2==0)
        if length(ind)>0
            disp('Attention fenêtre avec valeur nulle. Reconstruction incomplète');
        end
        
        ind=find(abs(sw2)>0);
        X(ind) = X(ind) ./ sw2(ind);
    end    
endfunction
// Choix du fichier son stéréophonique par l'utilisateur
nomFichier=uigetfile('*.wav',"");
[y,fs] = wavread(nomFichier);
[nbCanaux n]=size(y);
// Nombre de sources présentes dans le signal
[ok,nbSource]=getvalue("Nombre de sources à identifier",["Nombre de sources"],list("vec",1),["3"]);
// Choix de la fenêtre pour la TFCT
nomFenetre=['re';'tr';'hn';'hm';'kr';'ch'];
listeFenetre=list('Fenetre',1,['Rectangle','Triangle','Hann','Hamming','Kaiser','Chebyshev']);
chxFen=x_choices('Type de fenêtre pour la TFCT',list(listeFenetre));
// Choix de la taille de la fenêtre de pondération
[ok,w,q]=getvalue("Fenêtre de pondération",["Taille","valeur du décalage "],list("vec",1,"vec",1),["512","128"]);
if  chxFen==5  then
// Parametre pour la fenêtre de Kaiser
    [  ok  beta]=getvalue('Paramètre de la fenetre','Valeur du parametre',list('row',1),"10")
end
if  chxFen==6  then
// Parametre pour la fenêtre de Chebyshev
    [  ok  beta]=getvalue('Paramètre de la fenetre','Valeur du parametre compris entre 0 et 0.5',list('row',1),"0.2")
end
// Construction de la fenêtre de pondération
select(chxFen)
case  5  then
    fenetre=window(nomFenetre(chxFen),w,beta)';
case  6  then
    fenetre=window(nomFenetre(chxFen),w,[beta -1])';
else
    fenetre=window(nomFenetre(chxFen),w)';
end
// TFCT pour chaque signal capté par les microphones 1 et 2
R1=TFCT(y(1,:)',fenetre,q,-1);
R2=TFCT(y(2,:)',fenetre,q,-1);
// Nombre de fréquences
nbFreq = w;
// Nombre de spectres
nbSpec = size(R1,2);
figure(0);
clf();
// Représentation graphique de la TFCT du canal 1
subplot(2,1,1)
// Image du module de la TFCT du canal 1 normalisé entre 0 et 255
Matplot(256-abs(R1(nbFreq/2:-1:1,:))/max(abs(R1))*255);
// palette de 256 couleurs 
f=gcf();p = jetcolormap(256);f.color_map=p;f.background=-2;
// Construction des graduations et légendes sur les axes
// Axe des abscisses 
// Légendes pour chaque graduation
legGradx=[];
// 5 graduations
nbGradX=5
// Position des graduations
px=[];
for i=0:nbGradX-1
         ind=fix(i*size(R1,2)/(nbGradX-1))+1;
         px=[px ind];
         legGradx=[legGradx; string(fix(ind*q/fs*100)/100)];
end
// Axe des ordonnées
// Légendes pour chaque graduation
legGrady=[];
// 5 graduations
nbGradY=5;
// Position des graduations
py=[];
for i=0:nbGradY-1
         ind=fix(i*nbFreq/2/(nbGradY-1))+1;
         py=[py ind];
         legGrady=[ string(fix((nbGradY-1-i)/(nbGradY-1)*fs/2));legGrady];
end
// Structure des axes
aa=gca();
// Modification des légendes sur x
aa.x_ticks = tlist(["ticks", "locations", "labels"], px', legGradx);  
// Modification des légendes sur y
aa.y_ticks = tlist(["ticks", "locations", "labels"], py', legGrady);  
// Les axes sont affichés en bas à gauche
aa.x_location = 'bottom';
aa.y_location = 'left';
xlabel('$ Temps(s) $')
ylabel('$ \nu (Hz) $')
title('Transformée de Fourier à court terme du canal 1')

// Représentation graphique de la TFCT du canal 2
subplot(2,1,2)
Matplot(256-abs(R2(nbFreq/2:-1:1,:))/max(abs(R2))*256);
f=gcf();p = jetcolormap(256);f.color_map=p;f.background=-2;
// Structure des axes
aa=gca();
// Les axes sont les mêmes que le canal 1
aa.x_ticks = tlist(["ticks", "locations", "labels"], px', legGradx);  
aa.y_ticks = tlist(["ticks", "locations", "labels"], py', legGrady);  
aa.x_location = 'bottom';
aa.y_location = 'left';
xlabel('$ Temps(s) $')
ylabel('$ \nu (Hz) $')
title('Transformée de Fourier à court terme du canal 2')
// Module des TFCT des deux canaux sur deux colonnes
// A matrice nbFreq*nbSpec lignes par 2 colonnes
A=[abs(R1(:)) abs(R2(:))];
// Somme des colonnes de A
// d matrice nbFreq*nbSpec lignes par 1 colonne
d = sum(A,2);
// Tri de d par ordre décoissant avec 
// d(indCle(1)) plus grande valeur
// d(indCle(nbFreq*nbSpec )) plus petite valeur
[v,indCle] = gsort(d,'r','d');
// position 10% des points avec la plus grande énergie
indCle = indCle(1:round(10*nbFreq*nbSpec/100));
// valeur des points avec la plus forte énergie
P1 = A(indCle,:);  
// Calcul de l'angle des points
theta = atan(P1(:,2),P1(:,1));
figure(1);
clf;
// Tracé module de la TFCT du canal 2 en fonction TFCT du canal 1 
// pour les points de plus grande énergie
plot(A(indCle,1),A(indCle,2),'.')
// Histogramme des valeurs de theta en 50 classes    
nbClasse = 50;
// Graine des classes
posClasse=min( theta):(max(theta)-min(theta))/nbClasse:max(theta);
// Nombre d'éléments par classe
[ind h info]=dsearch(theta,posClasse);
// normalisation de l'histogramme
h = h/sum(h);
// Représentation graphique de l'histogramme
figure(2);
clf();
bar(posClasse(2:$),h); 
// Recherche des pics des histogrammes
s1 = [2:nbClasse nbClasse-1];
s2 = [2 1:nbClasse-1];
// recherche de la valeur et la position maximums locaux
I = find( h(s1)<h & h(s2)<h );
// recherche des maximums locaux 
[v,u] = gsort(h(I));  
// On les associe aux sources 
theta = posClasse(I(u(1:nbSource))); 
// Construction de la matrice de mélange
M = [cos(theta); sin(theta)];
// Projection des points sur les axes directuers des sources
Proj = M'*[R1(:) R2(:)]';
//recherche de la projection maximum par igne
[tmp,I] = max(abs(Proj), 'r');
// Matrice de taille équivalent à la TFCT
// avec I(i,j) indice de la source du point du spectre
I = matrix(I, [nbFreq nbSpec]);
// Recconstruction de la TFCT de chaque source
Xr=[];
for i=1:nbSource
    Xr(:,:,i) = matrix(Proj(i,:), [nbFreq nbSpec]) .* (I==i);
end
// TFCT inverse de chaque source
xr=[];
for i=1:nbSource
    xr(:,i)=TFCT(Xr(:,:,i),fenetre,q,n);
end
// Tracé des sources séparées
// et ecoute du signal de la source
figure(3);
clf;
for i=1:nbSource
    subplot(nbSource,1,i);
    plot(xr(:,i)/max(abs(xr(:,i)))); 
    title(['source ' string(i)]);
    sound(xr(:,i)/max(abs(xr(:,i))),fs);
    xpause(n/fs*1000000);
end

